(*
  Yacc parser template (TP Yacc V3.0), V1.2 6-17-91 AG
  hacked by alexm@hsys.msk.ru 25Oct97

  WARNING: this code is autogenerated from
  corresponding .y file, do not edit it by hand
*)

(* global definitions: *)


(*
   Yacc parser template (TP Yacc V3.0), V1.2 6-17-91 AG

   TP Yacc - Yet Another Compiler Compiler for MS-DOS/Turbo Pascal

   Version 3.0 as of April 91
   Version 3.0a as of May 92 (bug fixes in precedence and type information updates)

   Copyright (c) 1990,91 All rights reserved

   Author

   Albert Graef
   Schillerstr. 18
   6509 Schornsheim/Germany

   Graef@DMZRZU71.bitnet

   hacked by alexm@hsys.msk.ru 25Oct97 for Delphi 2.0+ compatibility
   - parser now uses yydebugoutput(msg : string) in debug mode instead of writeln
   - changed used units names;
   - fixed YYPARSE.COD searching;

   Synopsis   YACC [options] yacc-file[.Y] [output-file[.PAS]]

   Options

   /v  "Verbose:" Yacc generates a readable description of the generated
       parser, written to yacc-file with new extension .LST.

   /d  "Debug:" Yacc generates parser with debugging output.

   Description

   This is a reimplementation of the popular UNIX compiler generator
   Yacc for MS-DOS and Turbo Pascal.

   Differences from UNIX Yacc:

   - Produces output code for Turbo Pascal, rather than for C.

   - Does not support %union definitions. Instead, a value type is declared
     by specifying the type identifier *itself* as the tag of a %token
     or %type definition. Yacc will automatically generate an appropriate
     yylval variable of a variant record type (YYSType) which is capable of
     holding values of any of the types used in %token and %type.

     Type checking is *very* strict. If you use type definitions, then
     any symbol referred to in an action *must* have a type introduced
     in a type definition. Either the symbol must have been assigned a
     type in the definitions section, or the $<type-identifier> notation
     must be used. The syntax of the %type definition has been changed
     slightly to allow definitions of the form
       %type <type-identifier>
     (omitting the nonterminals) which may be used to declare types which
     are not assigned to any grammar symbol, but are used with the
     $<...> construct.

   - The parse tables constructed by this Yacc version are slightly greater
     than those constructed by UNIX Yacc, since a reduce action will only be
     chosen as the default action if it is the *only* action in the state.
     In difference, UNIX Yacc chooses a reduce action as the default action
     whenever it is the only *reduce* action of the state (even if there are
     other shift actions).

     This solves a bug in UNIX Yacc that makes the generated parser start
     error recovery too late with certain types of error productions (see
     also Schreiner/Friedman, "Introduction to compiler construction with
     UNIX," 1985). Also, errors will be caught sooner in most cases where
     standard Yacc would carry out an additional (default) reduction before
     detecting the error.
*)

program Yacc;
{$X+}
{$APPTYPE CONSOLE}

uses SysUtils, YaccLib, YaccBase, YaccMsgs, YaccSem, YaccTabl, YaccPars;

procedure yydebugoutput(msg : string);
begin
  WriteLn(msg);
end;

var methodof : String;

procedure write_out_parser_declaration;
begin
if methodof <> '' then begin
  writeLn(yyout);
  writeLn(yyout, 'function ' + methodof + '.yyparse : integer;');
end else begin
  writeLn(yyout);
  writeLn(yyout, 'function yylex : integer; forward;');
  writeLn(yyout);
  writeLn(yyout, 'function yyparse : integer;');
end;
end;

const ID = 257;
const C_ID = 258;
const LITERAL = 259;
const LITID = 260;
const NUMBER = 261;
const PTOKEN = 262;
const PLEFT = 263;
const PRIGHT = 264;
const PNONASSOC = 265;
const PTYPE = 266;
const PSTART = 267;
const PPREC = 268;
const PMETHODOF = 269;
const PP = 270;
const LCURL = 271;
const RCURL = 272;
const ILLEGAL = 273;

var yylval : YYSType;

(* here go yyparse and yylex declarations *)

function yylex : integer; forward;

function yyparse : integer;

var yystate, yysp, yyn : Integer;
    yys : array [1..yymaxdepth] of Integer;
    yyv : array [1..yymaxdepth] of YYSType;
    yyval : YYSType;

procedure yyaction ( yyruleno : Integer );
  (* local definitions: *)
begin
  (* actions: *)
  case yyruleno of
   1 : begin
         yyval := yyv[yysp-0];
       end;
   2 : begin
         yyval := yyv[yysp-0];
       end;
   3 : begin
         yyval := yyv[yysp-0];
       end;
   4 : begin
         yyval := yyv[yysp-0];
       end;
   5 : begin
         yyval := yyv[yysp-0];
       end;
   6 : begin
         yyerrok; 
       end;
   7 : begin
         yyerrok; 
       end;
   8 : begin
         yyerrok; 
       end;
   9 : begin
         yyerrok; 
       end;
  10 : begin
         yyerrok; 
       end;
  11 : begin
         yyerrok; 
       end;
  12 : begin
         yyval := yyv[yysp-0];
       end;
  13 : begin
         yyerrok; 
       end;
  14 : begin
         yyerrok; 
       end;
  15 : begin
         yyval := yyv[yysp-0];
       end;
  16 : begin
         yyval := yyv[yysp-0];
       end;
  17 : begin
         error(rcurl_expected); 
       end;
  18 : begin
         yyval := yyv[yysp-0];
       end;
  19 : begin
         yyerrok; 
       end;
  20 : begin
         yyerrok; 
       end;
  21 : begin
         yyerrok; 
       end;
  22 : begin
         yyval := yyv[yysp-0];
       end;
  23 : begin
         yyval := yyv[yysp-0];
       end;
  24 : begin
         error(rbrace_expected); 
       end;
  25 : begin
         yyval := yyv[yysp-0];
       end;
  26 : begin
         yyval := yyv[yysp-0];
       end;
  27 : begin
         error(rangle_expected); 
       end;
  28 : begin
         yyval := yyv[yysp-0];
       end;
  29 : begin
         sort_types;
         definitions;
         next_section;
         write_out_parser_declaration;
         next_section;
         
       end;
  30 : begin
         next_section;
         generate_parser;
         next_section; 
       end;
  31 : begin
         yyval := yyv[yysp-5];
       end;
  32 : begin
       end;
  33 : begin
         copy_rest_of_file; 
       end;
  34 : begin
       end;
  35 : begin
         yyerrok; 
       end;
  36 : begin
         error(error_in_def); 
       end;
  37 : begin
         startnt := ntsym(yyv[yysp-0]); 
       end;
  38 : begin
         error(ident_expected); 
       end;
  39 : begin
         copy_code; 
       end;
  40 : begin
         yyval := yyv[yysp-2];
       end;
  41 : begin
         act_prec := 0; 
       end;
  42 : begin
         yyval := yyv[yysp-3];
       end;
  43 : begin
         act_prec := new_prec_level(left); 
       end;
  44 : begin
         yyval := yyv[yysp-3];
       end;
  45 : begin
         act_prec := new_prec_level(right); 
       end;
  46 : begin
         yyval := yyv[yysp-3];
       end;
  47 : begin
         act_prec := new_prec_level(nonassoc); 
       end;
  48 : begin
         yyval := yyv[yysp-3];
       end;
  49 : begin
         yyval := yyv[yysp-2];
       end;
  50 : begin
         yyval := yyv[yysp-1];
       end;
  51 : begin
         methodof := sym_table[yyv[yysp-0]].pname^; 
       end;
  52 : begin
         act_type := 0; 
       end;
  53 : begin
         act_type := yyv[yysp-1]; add_type(yyv[yysp-1]); 
       end;
  54 : begin
         yyval := yyv[yysp-0];
       end;
  55 : begin
         yyerrok; 
       end;
  56 : begin
         yyerrok; 
       end;
  57 : begin
         error(ident_expected); 
       end;
  58 : begin
         error(error_in_def); 
       end;
  59 : begin
         error(ident_expected); 
       end;
  60 : begin
         if act_type<>0 then
         sym_type^[yyv[yysp-0]] := act_type;
         if act_prec<>0 then
         sym_prec^[yyv[yysp-0]] := act_prec; 
       end;
  61 : begin
         litsym(yyv[yysp-0], 0);
         if act_type<>0 then
         sym_type^[litsym(yyv[yysp-0], 0)] := act_type;
         if act_prec<>0 then
         sym_prec^[litsym(yyv[yysp-0], 0)] := act_prec; 
       end;
  62 : begin
         litsym(yyv[yysp-0], 0);
         if act_type<>0 then
         sym_type^[litsym(yyv[yysp-0], 0)] := act_type;
         if act_prec<>0 then
         sym_prec^[litsym(yyv[yysp-0], 0)] := act_prec; 
       end;
  63 : begin
         litsym(yyv[yysp-1], 0);
         if act_type<>0 then
         sym_type^[litsym(yyv[yysp-1], yyv[yysp-0])] := act_type;
         if act_prec<>0 then
         sym_prec^[litsym(yyv[yysp-1], 0)]  := act_prec; 
       end;
  64 : begin
         litsym(yyv[yysp-1], 0);
         if act_type<>0 then
         sym_type^[litsym(yyv[yysp-1], yyv[yysp-0])] := act_type;
         if act_prec<>0 then
         sym_prec^[litsym(yyv[yysp-1], 0)]  := act_prec; 
       end;
  65 : begin
         yyval := yyv[yysp-0];
       end;
  66 : begin
         yyerrok; 
       end;
  67 : begin
         yyerrok; 
       end;
  68 : begin
         error(ident_expected); 
       end;
  69 : begin
         error(error_in_def); 
       end;
  70 : begin
         error(ident_expected); 
       end;
  71 : begin
         if act_type<>0 then
         sym_type^[ntsym(yyv[yysp-0])] := act_type; 
       end;
  72 : begin
         next_section; 
       end;
  73 : begin
         yyval := yyv[yysp-1];
       end;
  74 : begin
         copy_code; 
       end;
  75 : begin
         next_section; 
       end;
  76 : begin
         yyval := yyv[yysp-4];
       end;
  77 : begin
         yyerrok; 
       end;
  78 : begin
         error(error_in_rule); 
       end;
  79 : begin
         error(error_in_rule); 
       end;
  80 : begin
         start_rule(ntsym(yyv[yysp-0])); 
       end;
  81 : begin
         start_body; 
       end;
  82 : begin
         end_body; 
       end;
  83 : begin
         yyval := yyv[yysp-0];
       end;
  84 : begin
         start_body; 
       end;
  85 : begin
         end_body; 
       end;
  86 : begin
       end;
  87 : begin
         add_symbol(yyv[yysp-0]); yyerrok; 
       end;
  88 : begin
         add_symbol(sym(yyv[yysp-0])); yyerrok; 
       end;
  89 : begin
         add_symbol(sym(yyv[yysp-0])); yyerrok; 
       end;
  90 : begin
         add_action; yyerrok; 
       end;
  91 : begin
         error(error_in_rule); 
       end;
  92 : begin
         copy_action; 
       end;
  93 : begin
         yyval := yyv[yysp-2];
       end;
  94 : begin
         copy_single_action; 
       end;
  95 : begin
       end;
  96 : begin
         add_rule_prec(yyv[yysp-0]); 
       end;
  97 : begin
         yyval := yyv[yysp-3];
       end;
  98 : begin
         add_rule_prec(litsym(yyv[yysp-0], 0)); 
       end;
  99 : begin
         yyval := yyv[yysp-3];
       end;
 100 : begin
         add_rule_prec(litsym(yyv[yysp-0], 0)); 
       end;
 101 : begin
         yyval := yyv[yysp-3];
       end;
 102 : begin
         yyval := yyv[yysp-1];
       end;
 103 : begin
       end;
 104 : begin
         add_action; 
       end;
  end;
end(*yyaction*);

(* parse table: *)

type YYARec = record
                sym, act : Integer;
              end;
     YYRRec = record
                len, sym : Integer;
              end;

const

yynacts   = 262;
yyngotos  = 148;
yynstates = 131;
yynrules  = 104;

yya : array [1..yynacts] of YYARec = (
{ 0: }
{ 1: }
  ( sym: 256; act: 13 ),
  ( sym: 262; act: 14 ),
  ( sym: 263; act: 15 ),
  ( sym: 264; act: 16 ),
  ( sym: 265; act: 17 ),
  ( sym: 266; act: 18 ),
  ( sym: 267; act: 19 ),
  ( sym: 269; act: 20 ),
  ( sym: 270; act: 21 ),
  ( sym: 271; act: 22 ),
{ 2: }
  ( sym: 0; act: 0 ),
{ 3: }
{ 4: }
{ 5: }
{ 6: }
  ( sym: 257; act: 26 ),
{ 7: }
  ( sym: 256; act: 28 ),
  ( sym: 257; act: 26 ),
{ 8: }
  ( sym: 60; act: 31 ),
  ( sym: 256; act: -52 ),
  ( sym: 257; act: -52 ),
  ( sym: 262; act: -52 ),
  ( sym: 263; act: -52 ),
  ( sym: 264; act: -52 ),
  ( sym: 265; act: -52 ),
  ( sym: 266; act: -52 ),
  ( sym: 267; act: -52 ),
  ( sym: 269; act: -52 ),
  ( sym: 270; act: -52 ),
  ( sym: 271; act: -52 ),
{ 9: }
{ 10: }
{ 11: }
{ 12: }
{ 13: }
{ 14: }
{ 15: }
{ 16: }
{ 17: }
{ 18: }
{ 19: }
{ 20: }
{ 21: }
{ 22: }
{ 23: }
  ( sym: 256; act: 37 ),
  ( sym: 272; act: 38 ),
{ 24: }
  ( sym: 256; act: 42 ),
  ( sym: 271; act: 22 ),
  ( sym: 258; act: -72 ),
{ 25: }
{ 26: }
{ 27: }
{ 28: }
{ 29: }
  ( sym: 256; act: 46 ),
  ( sym: 257; act: 26 ),
  ( sym: 262; act: -50 ),
  ( sym: 263; act: -50 ),
  ( sym: 264; act: -50 ),
  ( sym: 265; act: -50 ),
  ( sym: 266; act: -50 ),
  ( sym: 267; act: -50 ),
  ( sym: 269; act: -50 ),
  ( sym: 270; act: -50 ),
  ( sym: 271; act: -50 ),
{ 30: }
  ( sym: 257; act: 26 ),
{ 31: }
{ 32: }
  ( sym: 60; act: 31 ),
  ( sym: 256; act: -52 ),
  ( sym: 257; act: -52 ),
  ( sym: 259; act: -52 ),
  ( sym: 260; act: -52 ),
{ 33: }
  ( sym: 60; act: 31 ),
  ( sym: 256; act: -52 ),
  ( sym: 257; act: -52 ),
  ( sym: 259; act: -52 ),
  ( sym: 260; act: -52 ),
{ 34: }
  ( sym: 60; act: 31 ),
  ( sym: 256; act: -52 ),
  ( sym: 257; act: -52 ),
  ( sym: 259; act: -52 ),
  ( sym: 260; act: -52 ),
{ 35: }
  ( sym: 60; act: 31 ),
  ( sym: 256; act: -52 ),
  ( sym: 257; act: -52 ),
  ( sym: 259; act: -52 ),
  ( sym: 260; act: -52 ),
{ 36: }
{ 37: }
{ 38: }
{ 39: }
  ( sym: 258; act: 54 ),
{ 40: }
  ( sym: 124; act: 59 ),
  ( sym: 256; act: 60 ),
  ( sym: 258; act: 54 ),
  ( sym: 0; act: -30 ),
  ( sym: 270; act: -30 ),
{ 41: }
{ 42: }
{ 43: }
{ 44: }
  ( sym: 44; act: 64 ),
  ( sym: 256; act: 65 ),
  ( sym: 257; act: 26 ),
  ( sym: 262; act: -49 ),
  ( sym: 263; act: -49 ),
  ( sym: 264; act: -49 ),
  ( sym: 265; act: -49 ),
  ( sym: 266; act: -49 ),
  ( sym: 267; act: -49 ),
  ( sym: 269; act: -49 ),
  ( sym: 270; act: -49 ),
  ( sym: 271; act: -49 ),
{ 45: }
{ 46: }
{ 47: }
  ( sym: 62; act: 67 ),
  ( sym: 256; act: 68 ),
{ 48: }
  ( sym: 256; act: 74 ),
  ( sym: 257; act: 26 ),
  ( sym: 259; act: 75 ),
  ( sym: 260; act: 76 ),
{ 49: }
  ( sym: 256; act: 74 ),
  ( sym: 257; act: 26 ),
  ( sym: 259; act: 75 ),
  ( sym: 260; act: 76 ),
{ 50: }
  ( sym: 256; act: 74 ),
  ( sym: 257; act: 26 ),
  ( sym: 259; act: 75 ),
  ( sym: 260; act: 76 ),
{ 51: }
  ( sym: 256; act: 74 ),
  ( sym: 257; act: 26 ),
  ( sym: 259; act: 75 ),
  ( sym: 260; act: 76 ),
{ 52: }
{ 53: }
{ 54: }
{ 55: }
{ 56: }
{ 57: }
  ( sym: 270; act: 21 ),
  ( sym: 0; act: -32 ),
{ 58: }
{ 59: }
{ 60: }
{ 61: }
  ( sym: 256; act: 37 ),
  ( sym: 272; act: 38 ),
{ 62: }
{ 63: }
  ( sym: 256; act: 86 ),
  ( sym: 257; act: 26 ),
{ 64: }
{ 65: }
{ 66: }
{ 67: }
{ 68: }
{ 69: }
{ 70: }
  ( sym: 44; act: 64 ),
  ( sym: 256; act: 89 ),
  ( sym: 257; act: 26 ),
  ( sym: 259; act: 75 ),
  ( sym: 260; act: 76 ),
  ( sym: 262; act: -48 ),
  ( sym: 263; act: -48 ),
  ( sym: 264; act: -48 ),
  ( sym: 265; act: -48 ),
  ( sym: 266; act: -48 ),
  ( sym: 267; act: -48 ),
  ( sym: 269; act: -48 ),
  ( sym: 270; act: -48 ),
  ( sym: 271; act: -48 ),
{ 71: }
  ( sym: 261; act: 91 ),
  ( sym: 44; act: -61 ),
  ( sym: 256; act: -61 ),
  ( sym: 257; act: -61 ),
  ( sym: 259; act: -61 ),
  ( sym: 260; act: -61 ),
  ( sym: 262; act: -61 ),
  ( sym: 263; act: -61 ),
  ( sym: 264; act: -61 ),
  ( sym: 265; act: -61 ),
  ( sym: 266; act: -61 ),
  ( sym: 267; act: -61 ),
  ( sym: 269; act: -61 ),
  ( sym: 270; act: -61 ),
  ( sym: 271; act: -61 ),
{ 72: }
{ 73: }
  ( sym: 261; act: 91 ),
  ( sym: 44; act: -62 ),
  ( sym: 256; act: -62 ),
  ( sym: 257; act: -62 ),
  ( sym: 259; act: -62 ),
  ( sym: 260; act: -62 ),
  ( sym: 262; act: -62 ),
  ( sym: 263; act: -62 ),
  ( sym: 264; act: -62 ),
  ( sym: 265; act: -62 ),
  ( sym: 266; act: -62 ),
  ( sym: 267; act: -62 ),
  ( sym: 269; act: -62 ),
  ( sym: 270; act: -62 ),
  ( sym: 271; act: -62 ),
{ 74: }
{ 75: }
{ 76: }
{ 77: }
  ( sym: 44; act: 64 ),
  ( sym: 256; act: 89 ),
  ( sym: 257; act: 26 ),
  ( sym: 259; act: 75 ),
  ( sym: 260; act: 76 ),
  ( sym: 262; act: -46 ),
  ( sym: 263; act: -46 ),
  ( sym: 264; act: -46 ),
  ( sym: 265; act: -46 ),
  ( sym: 266; act: -46 ),
  ( sym: 267; act: -46 ),
  ( sym: 269; act: -46 ),
  ( sym: 270; act: -46 ),
  ( sym: 271; act: -46 ),
{ 78: }
  ( sym: 44; act: 64 ),
  ( sym: 256; act: 89 ),
  ( sym: 257; act: 26 ),
  ( sym: 259; act: 75 ),
  ( sym: 260; act: 76 ),
  ( sym: 262; act: -44 ),
  ( sym: 263; act: -44 ),
  ( sym: 264; act: -44 ),
  ( sym: 265; act: -44 ),
  ( sym: 266; act: -44 ),
  ( sym: 267; act: -44 ),
  ( sym: 269; act: -44 ),
  ( sym: 270; act: -44 ),
  ( sym: 271; act: -44 ),
{ 79: }
  ( sym: 44; act: 64 ),
  ( sym: 256; act: 89 ),
  ( sym: 257; act: 26 ),
  ( sym: 259; act: 75 ),
  ( sym: 260; act: 76 ),
  ( sym: 262; act: -42 ),
  ( sym: 263; act: -42 ),
  ( sym: 264; act: -42 ),
  ( sym: 265; act: -42 ),
  ( sym: 266; act: -42 ),
  ( sym: 267; act: -42 ),
  ( sym: 269; act: -42 ),
  ( sym: 270; act: -42 ),
  ( sym: 271; act: -42 ),
{ 80: }
  ( sym: 58; act: 94 ),
{ 81: }
{ 82: }
{ 83: }
{ 84: }
{ 85: }
{ 86: }
{ 87: }
{ 88: }
  ( sym: 256; act: 98 ),
  ( sym: 257; act: 26 ),
  ( sym: 259; act: 75 ),
  ( sym: 260; act: 76 ),
{ 89: }
{ 90: }
{ 91: }
{ 92: }
{ 93: }
{ 94: }
{ 95: }
  ( sym: 61; act: 108 ),
  ( sym: 123; act: 109 ),
  ( sym: 256; act: 110 ),
  ( sym: 257; act: 26 ),
  ( sym: 259; act: 75 ),
  ( sym: 260; act: 76 ),
  ( sym: 268; act: 111 ),
  ( sym: 0; act: -95 ),
  ( sym: 59; act: -95 ),
  ( sym: 124; act: -95 ),
  ( sym: 258; act: -95 ),
  ( sym: 270; act: -95 ),
{ 96: }
  ( sym: 258; act: 54 ),
{ 97: }
{ 98: }
{ 99: }
{ 100: }
{ 101: }
  ( sym: 59; act: 115 ),
  ( sym: 0; act: -85 ),
  ( sym: 124; act: -85 ),
  ( sym: 256; act: -85 ),
  ( sym: 258; act: -85 ),
  ( sym: 270; act: -85 ),
{ 102: }
{ 103: }
{ 104: }
  ( sym: 257; act: 26 ),
  ( sym: 259; act: 75 ),
  ( sym: 260; act: 76 ),
{ 105: }
{ 106: }
{ 107: }
{ 108: }
{ 109: }
{ 110: }
{ 111: }
{ 112: }
{ 113: }
  ( sym: 61; act: 108 ),
  ( sym: 123; act: 109 ),
  ( sym: 256; act: 110 ),
  ( sym: 257; act: 26 ),
  ( sym: 259; act: 75 ),
  ( sym: 260; act: 76 ),
  ( sym: 268; act: 111 ),
  ( sym: 0; act: -95 ),
  ( sym: 59; act: -95 ),
  ( sym: 124; act: -95 ),
  ( sym: 258; act: -95 ),
  ( sym: 270; act: -95 ),
{ 114: }
{ 115: }
{ 116: }
  ( sym: 125; act: 122 ),
  ( sym: 256; act: 123 ),
{ 117: }
{ 118: }
{ 119: }
{ 120: }
  ( sym: 59; act: 115 ),
  ( sym: 0; act: -82 ),
  ( sym: 124; act: -82 ),
  ( sym: 256; act: -82 ),
  ( sym: 258; act: -82 ),
  ( sym: 270; act: -82 ),
{ 121: }
{ 122: }
{ 123: }
{ 124: }
  ( sym: 61; act: 108 ),
  ( sym: 123; act: 109 ),
  ( sym: 0; act: -103 ),
  ( sym: 59; act: -103 ),
  ( sym: 124; act: -103 ),
  ( sym: 256; act: -103 ),
  ( sym: 258; act: -103 ),
  ( sym: 270; act: -103 ),
{ 125: }
  ( sym: 61; act: 108 ),
  ( sym: 123; act: 109 ),
  ( sym: 0; act: -103 ),
  ( sym: 59; act: -103 ),
  ( sym: 124; act: -103 ),
  ( sym: 256; act: -103 ),
  ( sym: 258; act: -103 ),
  ( sym: 270; act: -103 ),
{ 126: }
  ( sym: 61; act: 108 ),
  ( sym: 123; act: 109 ),
  ( sym: 0; act: -103 ),
  ( sym: 59; act: -103 ),
  ( sym: 124; act: -103 ),
  ( sym: 256; act: -103 ),
  ( sym: 258; act: -103 ),
  ( sym: 270; act: -103 )
{ 127: }
{ 128: }
{ 129: }
{ 130: }
);

yyg : array [1..yyngotos] of YYARec = (
{ 0: }
  ( sym: -28; act: 1 ),
  ( sym: -2; act: 2 ),
{ 1: }
  ( sym: -33; act: 3 ),
  ( sym: -17; act: 4 ),
  ( sym: -16; act: 5 ),
  ( sym: -15; act: 6 ),
  ( sym: -13; act: 7 ),
  ( sym: -12; act: 8 ),
  ( sym: -11; act: 9 ),
  ( sym: -10; act: 10 ),
  ( sym: -9; act: 11 ),
  ( sym: -8; act: 12 ),
{ 2: }
{ 3: }
{ 4: }
  ( sym: -34; act: 23 ),
{ 5: }
  ( sym: -30; act: 24 ),
{ 6: }
  ( sym: -3; act: 25 ),
{ 7: }
  ( sym: -3; act: 27 ),
{ 8: }
  ( sym: -35; act: 29 ),
  ( sym: -25; act: 30 ),
{ 9: }
  ( sym: -40; act: 32 ),
{ 10: }
  ( sym: -39; act: 33 ),
{ 11: }
  ( sym: -38; act: 34 ),
{ 12: }
  ( sym: -36; act: 35 ),
{ 13: }
{ 14: }
{ 15: }
{ 16: }
{ 17: }
{ 18: }
{ 19: }
{ 20: }
{ 21: }
{ 22: }
{ 23: }
  ( sym: -18; act: 36 ),
{ 24: }
  ( sym: -45; act: 39 ),
  ( sym: -29; act: 40 ),
  ( sym: -17; act: 41 ),
{ 25: }
{ 26: }
{ 27: }
{ 28: }
{ 29: }
  ( sym: -43; act: 43 ),
  ( sym: -41; act: 44 ),
  ( sym: -3; act: 45 ),
{ 30: }
  ( sym: -3; act: 47 ),
{ 31: }
{ 32: }
  ( sym: -35; act: 48 ),
  ( sym: -25; act: 30 ),
{ 33: }
  ( sym: -35; act: 49 ),
  ( sym: -25; act: 30 ),
{ 34: }
  ( sym: -35; act: 50 ),
  ( sym: -25; act: 30 ),
{ 35: }
  ( sym: -35; act: 51 ),
  ( sym: -25; act: 30 ),
{ 36: }
{ 37: }
{ 38: }
{ 39: }
  ( sym: -44; act: 52 ),
  ( sym: -4; act: 53 ),
{ 40: }
  ( sym: -48; act: 55 ),
  ( sym: -44; act: 56 ),
  ( sym: -32; act: 57 ),
  ( sym: -22; act: 58 ),
  ( sym: -4; act: 53 ),
{ 41: }
  ( sym: -46; act: 61 ),
{ 42: }
{ 43: }
{ 44: }
  ( sym: -43; act: 62 ),
  ( sym: -19; act: 63 ),
  ( sym: -3; act: 45 ),
{ 45: }
{ 46: }
{ 47: }
  ( sym: -26; act: 66 ),
{ 48: }
  ( sym: -42; act: 69 ),
  ( sym: -37; act: 70 ),
  ( sym: -6; act: 71 ),
  ( sym: -5; act: 72 ),
  ( sym: -3; act: 73 ),
{ 49: }
  ( sym: -42; act: 69 ),
  ( sym: -37; act: 77 ),
  ( sym: -6; act: 71 ),
  ( sym: -5; act: 72 ),
  ( sym: -3; act: 73 ),
{ 50: }
  ( sym: -42; act: 69 ),
  ( sym: -37; act: 78 ),
  ( sym: -6; act: 71 ),
  ( sym: -5; act: 72 ),
  ( sym: -3; act: 73 ),
{ 51: }
  ( sym: -42; act: 69 ),
  ( sym: -37; act: 79 ),
  ( sym: -6; act: 71 ),
  ( sym: -5; act: 72 ),
  ( sym: -3; act: 73 ),
{ 52: }
{ 53: }
  ( sym: -49; act: 80 ),
{ 54: }
{ 55: }
{ 56: }
{ 57: }
  ( sym: -31; act: 81 ),
  ( sym: -16; act: 82 ),
{ 58: }
  ( sym: -53; act: 83 ),
{ 59: }
{ 60: }
{ 61: }
  ( sym: -18; act: 84 ),
{ 62: }
{ 63: }
  ( sym: -43; act: 85 ),
  ( sym: -3; act: 45 ),
{ 64: }
{ 65: }
{ 66: }
{ 67: }
{ 68: }
{ 69: }
{ 70: }
  ( sym: -42; act: 87 ),
  ( sym: -19; act: 88 ),
  ( sym: -6; act: 71 ),
  ( sym: -5; act: 72 ),
  ( sym: -3; act: 73 ),
{ 71: }
  ( sym: -7; act: 90 ),
{ 72: }
{ 73: }
  ( sym: -7; act: 92 ),
{ 74: }
{ 75: }
{ 76: }
{ 77: }
  ( sym: -42; act: 87 ),
  ( sym: -19; act: 88 ),
  ( sym: -6; act: 71 ),
  ( sym: -5; act: 72 ),
  ( sym: -3; act: 73 ),
{ 78: }
  ( sym: -42; act: 87 ),
  ( sym: -19; act: 88 ),
  ( sym: -6; act: 71 ),
  ( sym: -5; act: 72 ),
  ( sym: -3; act: 73 ),
{ 79: }
  ( sym: -42; act: 87 ),
  ( sym: -19; act: 88 ),
  ( sym: -6; act: 71 ),
  ( sym: -5; act: 72 ),
  ( sym: -3; act: 73 ),
{ 80: }
  ( sym: -20; act: 93 ),
{ 81: }
{ 82: }
{ 83: }
  ( sym: -50; act: 95 ),
{ 84: }
  ( sym: -47; act: 96 ),
{ 85: }
{ 86: }
{ 87: }
{ 88: }
  ( sym: -42; act: 97 ),
  ( sym: -6; act: 71 ),
  ( sym: -5; act: 72 ),
  ( sym: -3; act: 73 ),
{ 89: }
{ 90: }
{ 91: }
{ 92: }
{ 93: }
  ( sym: -51; act: 99 ),
{ 94: }
{ 95: }
  ( sym: -54; act: 100 ),
  ( sym: -52; act: 101 ),
  ( sym: -27; act: 102 ),
  ( sym: -23; act: 103 ),
  ( sym: -14; act: 104 ),
  ( sym: -6; act: 105 ),
  ( sym: -5; act: 106 ),
  ( sym: -3; act: 107 ),
{ 96: }
  ( sym: -44; act: 112 ),
  ( sym: -4; act: 53 ),
{ 97: }
{ 98: }
{ 99: }
  ( sym: -50; act: 113 ),
{ 100: }
{ 101: }
  ( sym: -21; act: 114 ),
{ 102: }
{ 103: }
  ( sym: -55; act: 116 ),
{ 104: }
  ( sym: -6; act: 117 ),
  ( sym: -5; act: 118 ),
  ( sym: -3; act: 119 ),
{ 105: }
{ 106: }
{ 107: }
{ 108: }
{ 109: }
{ 110: }
{ 111: }
{ 112: }
{ 113: }
  ( sym: -54; act: 100 ),
  ( sym: -52; act: 120 ),
  ( sym: -27; act: 102 ),
  ( sym: -23; act: 103 ),
  ( sym: -14; act: 104 ),
  ( sym: -6; act: 105 ),
  ( sym: -5; act: 106 ),
  ( sym: -3; act: 107 ),
{ 114: }
{ 115: }
{ 116: }
  ( sym: -24; act: 121 ),
{ 117: }
  ( sym: -58; act: 124 ),
{ 118: }
  ( sym: -57; act: 125 ),
{ 119: }
  ( sym: -59; act: 126 ),
{ 120: }
  ( sym: -21; act: 114 ),
{ 121: }
{ 122: }
{ 123: }
{ 124: }
  ( sym: -56; act: 127 ),
  ( sym: -54; act: 128 ),
  ( sym: -27; act: 102 ),
  ( sym: -23; act: 103 ),
{ 125: }
  ( sym: -56; act: 129 ),
  ( sym: -54; act: 128 ),
  ( sym: -27; act: 102 ),
  ( sym: -23; act: 103 ),
{ 126: }
  ( sym: -56; act: 130 ),
  ( sym: -54; act: 128 ),
  ( sym: -27; act: 102 ),
  ( sym: -23; act: 103 )
{ 127: }
{ 128: }
{ 129: }
{ 130: }
);

yyd : array [0..yynstates-1] of Integer = (
{ 0: } -34,
{ 1: } 0,
{ 2: } 0,
{ 3: } -35,
{ 4: } -39,
{ 5: } -29,
{ 6: } 0,
{ 7: } 0,
{ 8: } 0,
{ 9: } -47,
{ 10: } -45,
{ 11: } -43,
{ 12: } -41,
{ 13: } -36,
{ 14: } -6,
{ 15: } -7,
{ 16: } -8,
{ 17: } -9,
{ 18: } -10,
{ 19: } -11,
{ 20: } -13,
{ 21: } -14,
{ 22: } -15,
{ 23: } 0,
{ 24: } 0,
{ 25: } -51,
{ 26: } -1,
{ 27: } -37,
{ 28: } -38,
{ 29: } 0,
{ 30: } 0,
{ 31: } -25,
{ 32: } 0,
{ 33: } 0,
{ 34: } 0,
{ 35: } 0,
{ 36: } -40,
{ 37: } -17,
{ 38: } -16,
{ 39: } 0,
{ 40: } 0,
{ 41: } -74,
{ 42: } -78,
{ 43: } -65,
{ 44: } 0,
{ 45: } -71,
{ 46: } -68,
{ 47: } 0,
{ 48: } 0,
{ 49: } 0,
{ 50: } 0,
{ 51: } 0,
{ 52: } -73,
{ 53: } -80,
{ 54: } -2,
{ 55: } -77,
{ 56: } -83,
{ 57: } 0,
{ 58: } -84,
{ 59: } -21,
{ 60: } -79,
{ 61: } 0,
{ 62: } -66,
{ 63: } 0,
{ 64: } -18,
{ 65: } -69,
{ 66: } -53,
{ 67: } -26,
{ 68: } -27,
{ 69: } -54,
{ 70: } 0,
{ 71: } 0,
{ 72: } -60,
{ 73: } 0,
{ 74: } -57,
{ 75: } -3,
{ 76: } -4,
{ 77: } 0,
{ 78: } 0,
{ 79: } 0,
{ 80: } 0,
{ 81: } -31,
{ 82: } -33,
{ 83: } -86,
{ 84: } -75,
{ 85: } -67,
{ 86: } -70,
{ 87: } -55,
{ 88: } 0,
{ 89: } -58,
{ 90: } -63,
{ 91: } -5,
{ 92: } -64,
{ 93: } -81,
{ 94: } -19,
{ 95: } 0,
{ 96: } 0,
{ 97: } -56,
{ 98: } -59,
{ 99: } -86,
{ 100: } -90,
{ 101: } 0,
{ 102: } -94,
{ 103: } -92,
{ 104: } 0,
{ 105: } -88,
{ 106: } -87,
{ 107: } -89,
{ 108: } -28,
{ 109: } -22,
{ 110: } -91,
{ 111: } -12,
{ 112: } -76,
{ 113: } 0,
{ 114: } -102,
{ 115: } -20,
{ 116: } 0,
{ 117: } -98,
{ 118: } -96,
{ 119: } -100,
{ 120: } 0,
{ 121: } -93,
{ 122: } -23,
{ 123: } -24,
{ 124: } 0,
{ 125: } 0,
{ 126: } 0,
{ 127: } -99,
{ 128: } -104,
{ 129: } -97,
{ 130: } -101
);

yyal : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 1,
{ 2: } 11,
{ 3: } 12,
{ 4: } 12,
{ 5: } 12,
{ 6: } 12,
{ 7: } 13,
{ 8: } 15,
{ 9: } 27,
{ 10: } 27,
{ 11: } 27,
{ 12: } 27,
{ 13: } 27,
{ 14: } 27,
{ 15: } 27,
{ 16: } 27,
{ 17: } 27,
{ 18: } 27,
{ 19: } 27,
{ 20: } 27,
{ 21: } 27,
{ 22: } 27,
{ 23: } 27,
{ 24: } 29,
{ 25: } 32,
{ 26: } 32,
{ 27: } 32,
{ 28: } 32,
{ 29: } 32,
{ 30: } 43,
{ 31: } 44,
{ 32: } 44,
{ 33: } 49,
{ 34: } 54,
{ 35: } 59,
{ 36: } 64,
{ 37: } 64,
{ 38: } 64,
{ 39: } 64,
{ 40: } 65,
{ 41: } 70,
{ 42: } 70,
{ 43: } 70,
{ 44: } 70,
{ 45: } 82,
{ 46: } 82,
{ 47: } 82,
{ 48: } 84,
{ 49: } 88,
{ 50: } 92,
{ 51: } 96,
{ 52: } 100,
{ 53: } 100,
{ 54: } 100,
{ 55: } 100,
{ 56: } 100,
{ 57: } 100,
{ 58: } 102,
{ 59: } 102,
{ 60: } 102,
{ 61: } 102,
{ 62: } 104,
{ 63: } 104,
{ 64: } 106,
{ 65: } 106,
{ 66: } 106,
{ 67: } 106,
{ 68: } 106,
{ 69: } 106,
{ 70: } 106,
{ 71: } 120,
{ 72: } 135,
{ 73: } 135,
{ 74: } 150,
{ 75: } 150,
{ 76: } 150,
{ 77: } 150,
{ 78: } 164,
{ 79: } 178,
{ 80: } 192,
{ 81: } 193,
{ 82: } 193,
{ 83: } 193,
{ 84: } 193,
{ 85: } 193,
{ 86: } 193,
{ 87: } 193,
{ 88: } 193,
{ 89: } 197,
{ 90: } 197,
{ 91: } 197,
{ 92: } 197,
{ 93: } 197,
{ 94: } 197,
{ 95: } 197,
{ 96: } 209,
{ 97: } 210,
{ 98: } 210,
{ 99: } 210,
{ 100: } 210,
{ 101: } 210,
{ 102: } 216,
{ 103: } 216,
{ 104: } 216,
{ 105: } 219,
{ 106: } 219,
{ 107: } 219,
{ 108: } 219,
{ 109: } 219,
{ 110: } 219,
{ 111: } 219,
{ 112: } 219,
{ 113: } 219,
{ 114: } 231,
{ 115: } 231,
{ 116: } 231,
{ 117: } 233,
{ 118: } 233,
{ 119: } 233,
{ 120: } 233,
{ 121: } 239,
{ 122: } 239,
{ 123: } 239,
{ 124: } 239,
{ 125: } 247,
{ 126: } 255,
{ 127: } 263,
{ 128: } 263,
{ 129: } 263,
{ 130: } 263
);

yyah : array [0..yynstates-1] of Integer = (
{ 0: } 0,
{ 1: } 10,
{ 2: } 11,
{ 3: } 11,
{ 4: } 11,
{ 5: } 11,
{ 6: } 12,
{ 7: } 14,
{ 8: } 26,
{ 9: } 26,
{ 10: } 26,
{ 11: } 26,
{ 12: } 26,
{ 13: } 26,
{ 14: } 26,
{ 15: } 26,
{ 16: } 26,
{ 17: } 26,
{ 18: } 26,
{ 19: } 26,
{ 20: } 26,
{ 21: } 26,
{ 22: } 26,
{ 23: } 28,
{ 24: } 31,
{ 25: } 31,
{ 26: } 31,
{ 27: } 31,
{ 28: } 31,
{ 29: } 42,
{ 30: } 43,
{ 31: } 43,
{ 32: } 48,
{ 33: } 53,
{ 34: } 58,
{ 35: } 63,
{ 36: } 63,
{ 37: } 63,
{ 38: } 63,
{ 39: } 64,
{ 40: } 69,
{ 41: } 69,
{ 42: } 69,
{ 43: } 69,
{ 44: } 81,
{ 45: } 81,
{ 46: } 81,
{ 47: } 83,
{ 48: } 87,
{ 49: } 91,
{ 50: } 95,
{ 51: } 99,
{ 52: } 99,
{ 53: } 99,
{ 54: } 99,
{ 55: } 99,
{ 56: } 99,
{ 57: } 101,
{ 58: } 101,
{ 59: } 101,
{ 60: } 101,
{ 61: } 103,
{ 62: } 103,
{ 63: } 105,
{ 64: } 105,
{ 65: } 105,
{ 66: } 105,
{ 67: } 105,
{ 68: } 105,
{ 69: } 105,
{ 70: } 119,
{ 71: } 134,
{ 72: } 134,
{ 73: } 149,
{ 74: } 149,
{ 75: } 149,
{ 76: } 149,
{ 77: } 163,
{ 78: } 177,
{ 79: } 191,
{ 80: } 192,
{ 81: } 192,
{ 82: } 192,
{ 83: } 192,
{ 84: } 192,
{ 85: } 192,
{ 86: } 192,
{ 87: } 192,
{ 88: } 196,
{ 89: } 196,
{ 90: } 196,
{ 91: } 196,
{ 92: } 196,
{ 93: } 196,
{ 94: } 196,
{ 95: } 208,
{ 96: } 209,
{ 97: } 209,
{ 98: } 209,
{ 99: } 209,
{ 100: } 209,
{ 101: } 215,
{ 102: } 215,
{ 103: } 215,
{ 104: } 218,
{ 105: } 218,
{ 106: } 218,
{ 107: } 218,
{ 108: } 218,
{ 109: } 218,
{ 110: } 218,
{ 111: } 218,
{ 112: } 218,
{ 113: } 230,
{ 114: } 230,
{ 115: } 230,
{ 116: } 232,
{ 117: } 232,
{ 118: } 232,
{ 119: } 232,
{ 120: } 238,
{ 121: } 238,
{ 122: } 238,
{ 123: } 238,
{ 124: } 246,
{ 125: } 254,
{ 126: } 262,
{ 127: } 262,
{ 128: } 262,
{ 129: } 262,
{ 130: } 262
);

yygl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 3,
{ 2: } 13,
{ 3: } 13,
{ 4: } 13,
{ 5: } 14,
{ 6: } 15,
{ 7: } 16,
{ 8: } 17,
{ 9: } 19,
{ 10: } 20,
{ 11: } 21,
{ 12: } 22,
{ 13: } 23,
{ 14: } 23,
{ 15: } 23,
{ 16: } 23,
{ 17: } 23,
{ 18: } 23,
{ 19: } 23,
{ 20: } 23,
{ 21: } 23,
{ 22: } 23,
{ 23: } 23,
{ 24: } 24,
{ 25: } 27,
{ 26: } 27,
{ 27: } 27,
{ 28: } 27,
{ 29: } 27,
{ 30: } 30,
{ 31: } 31,
{ 32: } 31,
{ 33: } 33,
{ 34: } 35,
{ 35: } 37,
{ 36: } 39,
{ 37: } 39,
{ 38: } 39,
{ 39: } 39,
{ 40: } 41,
{ 41: } 46,
{ 42: } 47,
{ 43: } 47,
{ 44: } 47,
{ 45: } 50,
{ 46: } 50,
{ 47: } 50,
{ 48: } 51,
{ 49: } 56,
{ 50: } 61,
{ 51: } 66,
{ 52: } 71,
{ 53: } 71,
{ 54: } 72,
{ 55: } 72,
{ 56: } 72,
{ 57: } 72,
{ 58: } 74,
{ 59: } 75,
{ 60: } 75,
{ 61: } 75,
{ 62: } 76,
{ 63: } 76,
{ 64: } 78,
{ 65: } 78,
{ 66: } 78,
{ 67: } 78,
{ 68: } 78,
{ 69: } 78,
{ 70: } 78,
{ 71: } 83,
{ 72: } 84,
{ 73: } 84,
{ 74: } 85,
{ 75: } 85,
{ 76: } 85,
{ 77: } 85,
{ 78: } 90,
{ 79: } 95,
{ 80: } 100,
{ 81: } 101,
{ 82: } 101,
{ 83: } 101,
{ 84: } 102,
{ 85: } 103,
{ 86: } 103,
{ 87: } 103,
{ 88: } 103,
{ 89: } 107,
{ 90: } 107,
{ 91: } 107,
{ 92: } 107,
{ 93: } 107,
{ 94: } 108,
{ 95: } 108,
{ 96: } 116,
{ 97: } 118,
{ 98: } 118,
{ 99: } 118,
{ 100: } 119,
{ 101: } 119,
{ 102: } 120,
{ 103: } 120,
{ 104: } 121,
{ 105: } 124,
{ 106: } 124,
{ 107: } 124,
{ 108: } 124,
{ 109: } 124,
{ 110: } 124,
{ 111: } 124,
{ 112: } 124,
{ 113: } 124,
{ 114: } 132,
{ 115: } 132,
{ 116: } 132,
{ 117: } 133,
{ 118: } 134,
{ 119: } 135,
{ 120: } 136,
{ 121: } 137,
{ 122: } 137,
{ 123: } 137,
{ 124: } 137,
{ 125: } 141,
{ 126: } 145,
{ 127: } 149,
{ 128: } 149,
{ 129: } 149,
{ 130: } 149
);

yygh : array [0..yynstates-1] of Integer = (
{ 0: } 2,
{ 1: } 12,
{ 2: } 12,
{ 3: } 12,
{ 4: } 13,
{ 5: } 14,
{ 6: } 15,
{ 7: } 16,
{ 8: } 18,
{ 9: } 19,
{ 10: } 20,
{ 11: } 21,
{ 12: } 22,
{ 13: } 22,
{ 14: } 22,
{ 15: } 22,
{ 16: } 22,
{ 17: } 22,
{ 18: } 22,
{ 19: } 22,
{ 20: } 22,
{ 21: } 22,
{ 22: } 22,
{ 23: } 23,
{ 24: } 26,
{ 25: } 26,
{ 26: } 26,
{ 27: } 26,
{ 28: } 26,
{ 29: } 29,
{ 30: } 30,
{ 31: } 30,
{ 32: } 32,
{ 33: } 34,
{ 34: } 36,
{ 35: } 38,
{ 36: } 38,
{ 37: } 38,
{ 38: } 38,
{ 39: } 40,
{ 40: } 45,
{ 41: } 46,
{ 42: } 46,
{ 43: } 46,
{ 44: } 49,
{ 45: } 49,
{ 46: } 49,
{ 47: } 50,
{ 48: } 55,
{ 49: } 60,
{ 50: } 65,
{ 51: } 70,
{ 52: } 70,
{ 53: } 71,
{ 54: } 71,
{ 55: } 71,
{ 56: } 71,
{ 57: } 73,
{ 58: } 74,
{ 59: } 74,
{ 60: } 74,
{ 61: } 75,
{ 62: } 75,
{ 63: } 77,
{ 64: } 77,
{ 65: } 77,
{ 66: } 77,
{ 67: } 77,
{ 68: } 77,
{ 69: } 77,
{ 70: } 82,
{ 71: } 83,
{ 72: } 83,
{ 73: } 84,
{ 74: } 84,
{ 75: } 84,
{ 76: } 84,
{ 77: } 89,
{ 78: } 94,
{ 79: } 99,
{ 80: } 100,
{ 81: } 100,
{ 82: } 100,
{ 83: } 101,
{ 84: } 102,
{ 85: } 102,
{ 86: } 102,
{ 87: } 102,
{ 88: } 106,
{ 89: } 106,
{ 90: } 106,
{ 91: } 106,
{ 92: } 106,
{ 93: } 107,
{ 94: } 107,
{ 95: } 115,
{ 96: } 117,
{ 97: } 117,
{ 98: } 117,
{ 99: } 118,
{ 100: } 118,
{ 101: } 119,
{ 102: } 119,
{ 103: } 120,
{ 104: } 123,
{ 105: } 123,
{ 106: } 123,
{ 107: } 123,
{ 108: } 123,
{ 109: } 123,
{ 110: } 123,
{ 111: } 123,
{ 112: } 123,
{ 113: } 131,
{ 114: } 131,
{ 115: } 131,
{ 116: } 132,
{ 117: } 133,
{ 118: } 134,
{ 119: } 135,
{ 120: } 136,
{ 121: } 136,
{ 122: } 136,
{ 123: } 136,
{ 124: } 140,
{ 125: } 144,
{ 126: } 148,
{ 127: } 148,
{ 128: } 148,
{ 129: } 148,
{ 130: } 148
);

yyr : array [1..yynrules] of YYRRec = (
{ 1: } ( len: 1; sym: -3 ),
{ 2: } ( len: 1; sym: -4 ),
{ 3: } ( len: 1; sym: -5 ),
{ 4: } ( len: 1; sym: -6 ),
{ 5: } ( len: 1; sym: -7 ),
{ 6: } ( len: 1; sym: -8 ),
{ 7: } ( len: 1; sym: -9 ),
{ 8: } ( len: 1; sym: -10 ),
{ 9: } ( len: 1; sym: -11 ),
{ 10: } ( len: 1; sym: -12 ),
{ 11: } ( len: 1; sym: -13 ),
{ 12: } ( len: 1; sym: -14 ),
{ 13: } ( len: 1; sym: -15 ),
{ 14: } ( len: 1; sym: -16 ),
{ 15: } ( len: 1; sym: -17 ),
{ 16: } ( len: 1; sym: -18 ),
{ 17: } ( len: 1; sym: -18 ),
{ 18: } ( len: 1; sym: -19 ),
{ 19: } ( len: 1; sym: -20 ),
{ 20: } ( len: 1; sym: -21 ),
{ 21: } ( len: 1; sym: -22 ),
{ 22: } ( len: 1; sym: -23 ),
{ 23: } ( len: 1; sym: -24 ),
{ 24: } ( len: 1; sym: -24 ),
{ 25: } ( len: 1; sym: -25 ),
{ 26: } ( len: 1; sym: -26 ),
{ 27: } ( len: 1; sym: -26 ),
{ 28: } ( len: 1; sym: -27 ),
{ 29: } ( len: 0; sym: -30 ),
{ 30: } ( len: 0; sym: -32 ),
{ 31: } ( len: 6; sym: -2 ),
{ 32: } ( len: 0; sym: -31 ),
{ 33: } ( len: 1; sym: -31 ),
{ 34: } ( len: 0; sym: -28 ),
{ 35: } ( len: 2; sym: -28 ),
{ 36: } ( len: 2; sym: -28 ),
{ 37: } ( len: 2; sym: -33 ),
{ 38: } ( len: 2; sym: -33 ),
{ 39: } ( len: 0; sym: -34 ),
{ 40: } ( len: 3; sym: -33 ),
{ 41: } ( len: 0; sym: -36 ),
{ 42: } ( len: 4; sym: -33 ),
{ 43: } ( len: 0; sym: -38 ),
{ 44: } ( len: 4; sym: -33 ),
{ 45: } ( len: 0; sym: -39 ),
{ 46: } ( len: 4; sym: -33 ),
{ 47: } ( len: 0; sym: -40 ),
{ 48: } ( len: 4; sym: -33 ),
{ 49: } ( len: 3; sym: -33 ),
{ 50: } ( len: 2; sym: -33 ),
{ 51: } ( len: 2; sym: -33 ),
{ 52: } ( len: 0; sym: -35 ),
{ 53: } ( len: 3; sym: -35 ),
{ 54: } ( len: 1; sym: -37 ),
{ 55: } ( len: 2; sym: -37 ),
{ 56: } ( len: 3; sym: -37 ),
{ 57: } ( len: 1; sym: -37 ),
{ 58: } ( len: 2; sym: -37 ),
{ 59: } ( len: 3; sym: -37 ),
{ 60: } ( len: 1; sym: -42 ),
{ 61: } ( len: 1; sym: -42 ),
{ 62: } ( len: 1; sym: -42 ),
{ 63: } ( len: 2; sym: -42 ),
{ 64: } ( len: 2; sym: -42 ),
{ 65: } ( len: 1; sym: -41 ),
{ 66: } ( len: 2; sym: -41 ),
{ 67: } ( len: 3; sym: -41 ),
{ 68: } ( len: 1; sym: -41 ),
{ 69: } ( len: 2; sym: -41 ),
{ 70: } ( len: 3; sym: -41 ),
{ 71: } ( len: 1; sym: -43 ),
{ 72: } ( len: 0; sym: -45 ),
{ 73: } ( len: 2; sym: -29 ),
{ 74: } ( len: 0; sym: -46 ),
{ 75: } ( len: 0; sym: -47 ),
{ 76: } ( len: 5; sym: -29 ),
{ 77: } ( len: 2; sym: -29 ),
{ 78: } ( len: 1; sym: -29 ),
{ 79: } ( len: 2; sym: -29 ),
{ 80: } ( len: 0; sym: -49 ),
{ 81: } ( len: 0; sym: -51 ),
{ 82: } ( len: 6; sym: -44 ),
{ 83: } ( len: 1; sym: -48 ),
{ 84: } ( len: 0; sym: -53 ),
{ 85: } ( len: 4; sym: -48 ),
{ 86: } ( len: 0; sym: -50 ),
{ 87: } ( len: 2; sym: -50 ),
{ 88: } ( len: 2; sym: -50 ),
{ 89: } ( len: 2; sym: -50 ),
{ 90: } ( len: 2; sym: -50 ),
{ 91: } ( len: 2; sym: -50 ),
{ 92: } ( len: 0; sym: -55 ),
{ 93: } ( len: 3; sym: -54 ),
{ 94: } ( len: 1; sym: -54 ),
{ 95: } ( len: 0; sym: -52 ),
{ 96: } ( len: 0; sym: -57 ),
{ 97: } ( len: 4; sym: -52 ),
{ 98: } ( len: 0; sym: -58 ),
{ 99: } ( len: 4; sym: -52 ),
{ 100: } ( len: 0; sym: -59 ),
{ 101: } ( len: 4; sym: -52 ),
{ 102: } ( len: 2; sym: -52 ),
{ 103: } ( len: 0; sym: -56 ),
{ 104: } ( len: 1; sym: -56 )
);


const _error = 256; (* error token *)

function yyact(state, sym : Integer; var act : Integer) : Boolean;
  (* search action table *)
  var k : Integer;
  begin
    k := yyal[state];
    while (k<=yyah[state]) and (yya[k].sym<>sym) do inc(k);
    if k>yyah[state] then
      yyact := false
    else
      begin
        act := yya[k].act;
        yyact := true;
      end;
  end(*yyact*);

function yygoto(state, sym : Integer; var nstate : Integer) : Boolean;
  (* search goto table *)
  var k : Integer;
  begin
    k := yygl[state];
    while (k<=yygh[state]) and (yyg[k].sym<>sym) do inc(k);
    if k>yygh[state] then
      yygoto := false
    else
      begin
        nstate := yyg[k].act;
        yygoto := true;
      end;
  end(*yygoto*);

label parse, next, error, errlab, shift, reduce, accept, abort;

begin(*yyparse*)

  (* initialize: *)

  yystate := 0; yychar := -1; yynerrs := 0; yyerrflag := 0; yysp := 0;

{$IFDEF yydebug}
  yydebug := true;
{$ELSE}
  yydebug := false;
{$ENDIF}

parse:

  (* push state and value: *)

  inc(yysp);
  if yysp>yymaxdepth then
    begin
      yyerror('yyparse stack overflow', yystate);
      goto abort;
    end;
  yys[yysp] := yystate; yyv[yysp] := yyval;

next:

  if (yyd[yystate]=0) and (yychar=-1) then
    (* get next symbol *)
    begin
      yychar := yylex; if yychar<0 then yychar := 0;
    end;

  if yydebug then yydebugoutput(Format('state %d, char %d ', [yystate, yychar]));
  
  (* determine parse action: *)

  yyn := yyd[yystate];
  if yyn<>0 then goto reduce; (* simple state *)

  (* no default action; search parse table *)

  if not yyact(yystate, yychar, yyn) then goto error
  else if yyn>0 then                      goto shift
  else if yyn<0 then                      goto reduce
  else                                    goto accept;

error:

  (* error; start error recovery: *)

  if yyerrflag=0 then yyerror('syntax error', yystate);

errlab:

  if yyerrflag=0 then inc(yynerrs);     (* new error *)

  if yyerrflag<=2 then                  (* incomplete recovery; try again *)
    begin
      yyerrflag := 3;
      (* uncover a state with shift action on error token *)
      while (yysp>0) and not ( yyact(yys[yysp], _error, yyn) and
                               (yyn>0) ) do
        begin
          if yydebug then
            if yysp>1 then
              yydebugoutput(Format('error recovery pops state %d, uncovers %d',
                     [yys[yysp], yys[yysp-1]]))
            else
              yydebugoutput('error recovery fails ... abort');
          dec(yysp);
        end;
      if yysp=0 then goto abort; (* parser has fallen from stack; abort *)
      yystate := yyn;            (* simulate shift on error *)
      goto parse;
    end
  else                                  (* no shift yet; discard symbol *)
    begin
      if yydebug then yydebugoutput(Format('error recovery discards char %d', [yychar]));
      if yychar=0 then goto abort; (* end of input; abort *)
      yychar := -1; goto next;     (* clear lookahead char and try again *)
    end;

shift:

  (* go to new state, clear lookahead character: *)

  yystate := yyn; yychar := -1; yyval := yylval;
  if yyerrflag>0 then dec(yyerrflag);

  goto parse;

reduce:

  (* execute action, pop rule from stack, and go to next state: *)

  if yydebug then yydebugoutput(Format('reduce %d', [-yyn]));

  yyflag := yyfnone; yyaction(-yyn);
  dec(yysp, yyr[-yyn].len);
  if yygoto(yys[yysp], yyr[-yyn].sym, yyn) then yystate := yyn;

  (* handle action calls to yyaccept, yyabort and yyerror: *)

  case yyflag of
    yyfaccept : goto accept;
    yyfabort  : goto abort;
    yyferror  : goto errlab;
  end;

  goto parse;

accept:

  yyparse := 0; exit;

abort:

  yyparse := 1; exit;

end(*yyparse*);


(* Lexical analyzer (implemented in Turbo Pascal for maximum efficiency): *)

function yylex : integer;
  function end_of_input : boolean;
    begin
      end_of_input := (cno>length(line)) and eof(yyin)
    end(*end_of_input*);
  procedure scan;
    (* scan for nonempty character, skip comments *)
    procedure scan_comment;
      var p : integer;
      begin
        p := pos('*/', copy(line, cno, length(line)));
        if p>0 then
          cno := cno+succ(p)
        else
          begin
            while (p=0) and not eof(yyin) do
              begin
                readln(yyin, line);
                inc(lno);
                p := pos('*/', line)
              end;
            if p=0 then
              begin
                cno := succ(length(line));
                error(open_comment_at_eof);
              end
            else
              cno := succ(succ(p))
          end
      end(*scan_comment*);
    begin
      while not end_of_input do
        if cno<=length(line) then
          case line[cno] of
            ' ', tab : inc(cno);
            '/' :
              if (cno<length(line)) and (line[succ(cno)]='*') then
                begin
                  inc(cno, 2);
                  scan_comment
                end
              else
                exit
            else
              exit
          end
        else
          begin
            readln(yyin, line);
            inc(lno); cno := 1;
          end
    end(*scan*);
  function scan_ident : integer;
    (* scan an identifier *)
    var
      idstr : String;
    begin
      idstr := line[cno];
      inc(cno);
      while (cno<=length(line)) and (
            ('A'<=upCase(line[cno])) and (upCase(line[cno])<='Z') or
            ('0'<=line[cno]) and (line[cno]<='9') or
            (line[cno]='_') or
            (line[cno]='.') ) do
	begin
	  idstr := idstr+line[cno];
	  inc(cno)
	end;
      yylval := get_key(idstr);
      scan;
      if not end_of_input and (line[cno]=':') then
        scan_ident := C_ID
      else
        scan_ident := ID
    end(*scan_ident*);
  function scan_literal: integer;
    (* scan a literal, i.e. string *)
    var
      idstr : String;
      oct_val : Byte;
    begin
      idstr := line[cno];
      inc(cno);
      while (cno<=length(line)) and (line[cno]<>idstr[1]) do
        if line[cno]='\' then
          if cno<length(line) then
            begin
              inc(cno);
              case line[cno] of
                'n' :
                  begin
                    idstr := idstr+nl;
                    inc(cno)
                  end;
                'r' :
                  begin
                    idstr := idstr+cr;
                    inc(cno)
                  end;
                't' :
                  begin
                    idstr := idstr+tab;
                    inc(cno)
                  end;
                'b' :
                  begin
                    idstr := idstr+bs;
                    inc(cno)
                  end;
                'f' :
                  begin
                    idstr := idstr+ff;
                    inc(cno)
                  end;
                '0'..'7' :
                  begin
                    oct_val := ord(line[cno])-ord('0');
                    inc(cno);
                    while (cno<=length(line)) and
                          ('0'<=line[cno]) and
                          (line[cno]<='7') do
                      begin
                        oct_val := oct_val*8+ord(line[cno])-ord('0');
                        inc(cno)
                      end;
                    idstr := idstr+chr(oct_val)
                  end
                else
                  begin
                    idstr := idstr+line[cno];
                    inc(cno)
                  end
              end
            end
          else
            inc(cno)
        else
          begin
            idstr := idstr+line[cno];
            inc(cno)
          end;
      if cno>length(line) then
        error(missing_string_terminator)
      else
        inc(cno);
      if length(idstr)=2 then
        begin
          yylval := ord(idstr[2]);
          scan_literal := LITERAL;
        end
      else if length(idstr)>1 then
        begin
          yylval := get_key(''''+copy(idstr, 2, pred(length(idstr)))+'''');
          scan_literal := LITID;
        end
      else
        scan_literal := ILLEGAL;
    end(*scan_literal*);
  function scan_num : integer;
    (* scan an unsigned integer *)
    var
      numstr : String;
      code : integer;
    begin
      numstr := line[cno];
      inc(cno);
      while (cno<=length(line)) and
            ('0'<=line[cno]) and (line[cno]<='9') do
        begin
          numstr := numstr+line[cno];
          inc(cno)
        end;
      val(numstr, yylval, code);
      if code=0 then
        scan_num := NUMBER
      else
        scan_num := ILLEGAL;
    end(*scan_num*);
  function scan_keyword : integer;
    (* scan %xy *)
    function lookup(key : String; var tok : integer) : boolean;
      (* table of Yacc keywords (unstropped): *)
      const
        no_of_entries = 12;
        max_entry_length = 8;
        keys : array [1..no_of_entries] of String[max_entry_length] = (
          '0', '2', 'binary', 'left', 'methodof', 'nonassoc', 'prec', 'right',
          'start', 'term', 'token', 'type');
        toks : array [1..no_of_entries] of integer = (
          PTOKEN, PNONASSOC, PNONASSOC, PLEFT, PMETHODOF, PNONASSOC, PPREC, PRIGHT,
          PSTART, PTOKEN, PTOKEN, PTYPE);
      var m, n, k : integer;
      begin
        (* binary search: *)
        m := 1; n := no_of_entries;
        lookup := true;
        while m<=n do
          begin
            k := m+(n-m) div 2;
            if key=keys[k] then
              begin
                tok := toks[k];
                exit
              end
            else if key>keys[k] then
              m := k+1
            else
              n := k-1
          end;
        lookup := false
      end(*lookup*);
    var
      keywstr : String;
      tok : integer;
    begin
      inc(cno);
      if cno<=length(line) then
        case line[cno] of
          '<' :
            begin
              scan_keyword := PLEFT;
              inc(cno)
            end;
          '>' :
            begin
              scan_keyword := PRIGHT;
              inc(cno)
            end;
          '=' :
            begin
              scan_keyword := PPREC;
              inc(cno)
            end;
          '%', '\' :
            begin
              scan_keyword := PP;
              inc(cno)
            end;
          '{' :
            begin
              scan_keyword := LCURL;
              inc(cno)
            end;
          '}' :
            begin
              scan_keyword := RCURL;
              inc(cno)
            end;
          'A'..'Z', 'a'..'z', '0'..'9' :
            begin
              keywstr := line[cno];
              inc(cno);
              while (cno<=length(line)) and (
                    ('A'<=upCase(line[cno])) and (upCase(line[cno])<='Z') or
                    ('0'<=line[cno]) and (line[cno]<='Z') ) do
                begin
                  keywstr := keywstr+line[cno];
                  inc(cno)
                end;
              if lookup(keywstr, tok) then
                scan_keyword := tok
              else
                scan_keyword := ILLEGAL
            end;
          else scan_keyword := ILLEGAL
        end
      else
        scan_keyword := ILLEGAL;
    end(*scan_keyword*);
  function scan_char : integer;
    (* scan any single character *)
    begin
      scan_char := ord(line[cno]);
      inc(cno)
    end(*scan_char*);
  var lno0, cno0 : integer;
  begin
    tokleng := 0;
    scan;
    lno0 := lno; cno0 := cno;
    if end_of_input then
      yylex := 0
    else
      case line[cno] of
        'A'..'Z', 'a'..'z', '_' : yylex := scan_ident;
	'''', '"' : yylex := scan_literal;
	'0'..'9' : yylex := scan_num;
	'%', '\' : yylex := scan_keyword;
        '=' :
          if (cno<length(line)) and (line[succ(cno)]='{') then
            begin
              inc(cno);
              yylex := scan_char
            end
          else
            yylex := scan_char;
	else yylex := scan_char;
      end;
    if lno=lno0 then
      tokleng := cno-cno0
  end(*yylex*);

(* Main program: *)

var i : Integer;

begin

  (* sign-on: *)

  writeln(sign_on);

  (* parse command line: *)

  if paramCount=0 then
    begin
      writeln(usage);
      writeln(options);
      halt(0);
    end;

  yfilename := '';
  pasfilename := '';

  for i := 1 to paramCount do
    if copy(paramStr(i), 1, 1)='/' then
      if upper(paramStr(i))='/V' then
        verbose := true
      else if upper(paramStr(i))='/D' then
        debug := true
      else
        begin
          writeln(invalid_option, paramStr(i));
          halt(1);
        end
    else if yfilename='' then
      yfilename := addExt(paramStr(i), 'y')
    else if pasfilename='' then
      pasfilename := addExt(paramStr(i), 'pas')
    else
      begin
        writeln(illegal_no_args);
        halt(1);
      end;

  if yfilename='' then
    begin
      writeln(illegal_no_args);
      halt(1);
    end;

  if pasfilename='' then pasfilename := root(yfilename)+'.pas';
  lstfilename := root(yfilename)+'.lst';

  (* open files: *)

  assign(yyin, yfilename);
  assign(yyout, pasfilename);
  assign(yylst, lstfilename);

  reset(yyin);    if ioresult<>0 then fatal(cannot_open_file+yfilename);
  rewrite(yyout); if ioresult<>0 then fatal(cannot_open_file+pasfilename);
  rewrite(yylst); if ioresult<>0 then fatal(cannot_open_file+lstfilename);

  (* search code template in current directory, then on path where Yacc
     was executed from: *)
  codfilename := 'yyparse.cod';
{$I-}
  assign(yycod, codfilename);
  reset(yycod);
  if ioresult<>0 then
    begin
      codfilename := path(paramStr(0))+codfilename;
      assign(yycod, codfilename);
      reset(yycod);
      if ioresult<>0 then fatal(cannot_open_file+codfilename);
    end;
{$I+}

  (* parse source grammar: *)

  write('parse ... ');

  lno := 0; cno := 1; line := '';

  next_section;
  if debug then writeln(yyout, '{$define yydebug}');

  if yyparse=0 then
    { done }
  else if yychar=0 then
    error(unexpected_eof)
  else
    error(syntax_error);

  if errors=0 then writeln('DONE');

  (* close files: *)

  close(yyin); close(yyout); close(yylst); close(yycod);

  (* print statistics: *)

  if errors>0 then
    writeln( lno, ' lines, ',
             errors, ' errors found.' )
  else
    begin
      writeln( lno, ' lines, ',
               n_rules-1, '/', max_rules-1, ' rules, ',
               n_states, '/', max_states, ' s, ',
               n_items, '/', max_items, ' i, ',
               n_trans, '/', max_trans, ' t, ',
               n_redns, '/', max_redns, ' r.');
      if shift_reduce>0 then
        writeln(shift_reduce, ' shift/reduce conflicts.');
      if reduce_reduce>0 then
        writeln(reduce_reduce, ' reduce/reduce conflicts.');
      if never_reduced>0 then
        writeln(never_reduced, ' rules never reduced.');
    end;

  if warnings>0 then writeln(warnings, ' warnings.');

  writeln( n_bytes, '/', max_bytes, ' bytes of memory used.');

  (* terminate: *)

  if errors>0 then
    begin
      erase(yyout);
      if ioresult<>0 then ;
    end;

  if file_size(lstfilename)=0 then
    erase(yylst)
  else
    writeln('(see ', lstfilename, ' for more information)');

  //halt(errors);

end(*Yacc*).